using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_KairosPRO._1_Modelos;
using Exferia_KairosPRO._4_Vistas.Controladoras;
using Exferia_KairosPRO.General;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_KairosPRO._4_Vistas
{
    public partial class P_Calendario_Detalle : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        P_Calendario_Detalle_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;

        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        public int g_int_TipoApertura = 0;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;
        private List<INTERNO_AUX_Calendario_Modelo> g_lst_INTERNO_AUX_Calendario_Modelo = null;
        public List<List<DateTime>> g_lst_Rangos_Fechas = null;
        #endregion

        #region Objetos en pantalla
        //Exferia_Button
        internal Exferia_Button Exferia_Button_Calendario_Detalle_Grabar { get { return ex_btn_P_Calendario_Detalle_Grabar; } }
        internal Exferia_Button Exferia_Button_Calendario_Detalle_Borrar { get { return ex_btn_P_Calendario_Detalle_Borrar; } }

        //Exferia_ComboBox
        internal Exferia_ComboBox Exferia_ComboBox_AuPre_Programadas { get { return ex_cbo_P_Calendario_Detalle_AUPRE_Programadas; } }
        internal Exferia_ComboBox Exferia_ComboBox_JornadasCabeceras { get { return ex_cbo_P_Calendario_Detalle_JornadaCabecera; } }

        //Exferia_FechaSeleccion
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaDesde { get { return usc_ex_P_Calendario_Detalle_FechaDesde; } }
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaHasta { get { return usc_ex_P_Calendario_Detalle_FechaHasta; } }

        //Exferia_Label
        internal Exferia_Label Exferia_Label_Descripcion { get { return ex_lbl_P_Calendario_Detalle_Descripcion; } }
        internal Exferia_Label Exferia_Label_AuPre_Programadas { get { return ex_lbl_P_Calendario_Detalle_AUPRE_Programadas; } }
        internal Exferia_Label Exferia_Label_JornadasCabeceras { get { return ex_lbl_P_Calendario_Detalle_JornadaCabecera; } }

        //Label
        internal Label Label_NombreEmpleado { get { return lbl_P_Calendario_Detalle_NombreEmpleado; } }

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Descripcion { get { return ex_txt_P_Calendario_Detalle_Descripcion; } }
        #endregion

        #region Constructor
        public P_Calendario_Detalle(int _int_TipoApertura, P_Calendario_Controladora _obj_Calendario_Controladora, long _lng_id, INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle, INTERNO_AUX_Empleado_Modelo _mdl_INTERNO_AUX_Empleado_Modelo, List<List<DateTime>> _lst_Rangos_Fechas, List<INTERNO_AUX_Calendario_Modelo> _lst_INTERNO_AUX_Calendario_Modelo)
        {
            InitializeComponent();

            Repintar.Empezar(this);

            CheckForIllegalCrossThreadCalls = false;

            //Comprobamos que el codigo cliente exista y este bien
            if (Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO.Equals(-1))
            {
                //Tendriamos que avisar y no dejar abrir la pantalla
                Mensajes.MostrarMensaje(Mensajes.G_STR_LICENCIA_VALIDACIONES_LICENCIANOESTAACTIVA);
                Salir_P_Base();
            }
            
            //Empresa seleccionada y fecha de trabajo ....................................................
            P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
            P_Base_FechaTrabajo = _dtt_FechaTrabajo;

            //Tipo de apertura
            g_int_TipoApertura = _int_TipoApertura;

            if (_lst_INTERNO_AUX_Calendario_Modelo != null && 
                !_lst_INTERNO_AUX_Calendario_Modelo.Exists(x => x==null))
            {
                g_lst_INTERNO_AUX_Calendario_Modelo = _lst_INTERNO_AUX_Calendario_Modelo;
            }

            //Asignamos el nombre del empleado en cuestion
            if (_mdl_INTERNO_AUX_Empleado_Modelo != null && _mdl_INTERNO_AUX_Empleado_Modelo.NombreEmpleado.Trim().Length != 0)
            {
                lbl_P_Calendario_Detalle_NombreEmpleado.Text = _mdl_INTERNO_AUX_Empleado_Modelo.NombreEmpleado;
            }

            //Asigamos los rangos de fechas al listado general
            g_lst_Rangos_Fechas = _lst_Rangos_Fechas;

            //Obtenemos el id del Objeto a modificar (Presencia, Festivo)
            P_Base_id = _lng_id;

            //Datos de Opciones detalle
            g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

            //#########################################################
            //Cargamos el detalle segun el tipo de objeto que obtengamos
            Cargar_Detalle_SegunTipoObjeto();
            //##########################################################

            //Instanciar Controladora
            g_obj_Controladora = new P_Calendario_Detalle_Controladora(this, _obj_Calendario_Controladora, _mdl_INTERNO_AUX_Empleado_Modelo != null ? _mdl_INTERNO_AUX_Empleado_Modelo.id : -1, g_lst_INTERNO_AUX_Calendario_Modelo);
            
            //Buscar los Permisos
            g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

            //Poner los botones que no se puedan poner bloqueados o solo de lectura
            ex_btn_P_Calendario_Detalle_Grabar.Exferia_Button_Bloqueable = false;

            //Mirar si hay que bloquear los controles, si solo puede ver los datos
            if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
            {
                //Bloqueo los Controles
                SoloLectura.Empezar(this, true);
            }

            try
            {
                //Label con Empresa Seleccionada
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_Calendario_Detalle) + "/" + nameof(P_Calendario_Detalle));
                    }
                }
                //..................................................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto.....
                Enabled = false;
                //.............................................................
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                Control_Errores.Errores_Log("", ex, nameof(P_Calendario_Detalle) + "/" + nameof(P_Calendario_Detalle));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }
        }
        #endregion

        #region Inicio de pantalla
        private void P_Calendario_Detalle_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;

                        ActivarBotones(false);

                        //Poner Texto predeterminado y foco
                        if ((P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0) ||
                            (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0))
                        {
                            if (P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0)
                            {
                                ex_txt_P_Calendario_Detalle_Descripcion.Text = P_Base_Campo_1;
                                
                            }
                            if (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0)
                            {
                                
                                ex_txt_P_Calendario_Detalle_Descripcion.Exferia_TextBox_Foco();
                            }
                        }
                        else
                        {
                            ex_txt_P_Calendario_Detalle_Descripcion.Exferia_TextBox_Foco();
                        }
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                    }
                    //Modificar
                    else
                    {
                        ActivarBotones(true);

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Calendario_Detalle) + "/" + nameof(P_Calendario_Detalle_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }

        public void ActivarBotones(bool _bol_Activar)
        {
            if (ex_btn_P_Calendario_Detalle_Borrar.Enabled)
            {
                ex_btn_P_Calendario_Detalle_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Botones Grabar, Borrar
        private void ex_btn_P_Calendario_Detalle_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if ( //Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos(true);
            }
        }

        private void ex_btn_P_Calendario_Detalle_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(true);
            }
        }
        #endregion

        #region Teclas de acceso rapido
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        #endregion

        #region Controlar si se modifica algo
        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_ComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion

        private void Cargar_Detalle_SegunTipoObjeto()
        {
            try
            {
                //Hay mas de un rango de fechas
                if (g_lst_Rangos_Fechas != null && g_lst_Rangos_Fechas.Count > 1)
                {
                    if (g_int_TipoApertura.Equals(1))//Dias Festivo
                    {
                        //Movemos y hacemos invisible los controles necesarios
                        lbl_P_Calendario_Detalle_NombreEmpleado.Visible = false;
                        pnl_P_Calendario_Detalle_TipoAUPRE_Jornada.Visible = false;
                        pnl_P_Calendario_Detalle_JornadaCabecera.Visible = false;
                        pnl_P_Calendario_Detalle_FechasDinamicas.Location = new Point(pnl_P_Calendario_Detalle_FechasDinamicas.Location.X, pnl_P_Calendario_Detalle_FechasDinamicas.Location.Y - 160);

                        //Titulo de la Pantalla ............................................................................
                        P_Base_TituloPantalla = g_mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento + " - " + Variables_KairosPRO.G_STR_CALENDARIO_DETALLE_TITULO_DIAFESTIVO;

                        //Creamos los labels con los rangos de fechas
                        Generar_FechasDinamicas();
                    }
                    else if (g_int_TipoApertura.Equals(2))//Presencia Programada
                    {
                        //Movemos y hacemos invisible los controles necesarios
                        ex_lbl_P_Calendario_Detalle_AUPRE_Programadas.Text = Variables_KairosPRO.G_STR_CALENDARIO_DETALLE_COMBOBOX_PRESENCIAPROGRAMADATIPO;
                        pnl_P_Calendario_Detalle_Descripcion.Visible = false;
                        pnl_P_Calendario_Detalle_TipoAUPRE_Jornada.Location = new Point(pnl_P_Calendario_Detalle_TipoAUPRE_Jornada.Location.X, (pnl_P_Calendario_Detalle_TipoAUPRE_Jornada.Location.Y - 40));
                        pnl_P_Calendario_Detalle_JornadaCabecera.Location = new Point(pnl_P_Calendario_Detalle_JornadaCabecera.Location.X, pnl_P_Calendario_Detalle_JornadaCabecera.Location.Y - 40);
                        pnl_P_Calendario_Detalle_FechasDinamicas.Location = new Point(pnl_P_Calendario_Detalle_FechasDinamicas.Location.X, pnl_P_Calendario_Detalle_FechasDinamicas.Location.Y - 120);

                        //Titulo de la Pantalla ............................................................................
                        P_Base_TituloPantalla = g_mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento + " - " + Variables_KairosPRO.G_STR_CALENDARIO_DETALLE_TITULO_PRESENCIAPROGRAMADA;

                        //Creamos los labels con los rangos de fechas
                        Generar_FechasDinamicas();
                    }
                    
                }
                else
                {
                    //Si estan en el mismo rango, pero no cogen el registro completo, no les dejo modificar la fecha
                    if (g_lst_INTERNO_AUX_Calendario_Modelo != null)
                    {
                        usc_ex_P_Calendario_Detalle_FechaDesde.Enabled = false;
                        usc_ex_P_Calendario_Detalle_FechaHasta.Enabled = false;
                    }
                    if (g_int_TipoApertura.Equals(1))//Dia Festivo
                    {
                        pnl_P_Calendario_Detalle_TipoAUPRE_Jornada.Visible = false;
                        pnl_P_Calendario_Detalle_JornadaCabecera.Visible = false;
                        lbl_P_Calendario_Detalle_NombreEmpleado.Visible = false;
                        usc_ex_P_Calendario_Detalle_FechaDesde.Location = new Point(usc_ex_P_Calendario_Detalle_FechaDesde.Location.X + 4, usc_ex_P_Calendario_Detalle_FechaDesde.Location.Y - 90);
                        usc_ex_P_Calendario_Detalle_FechaHasta.Location = new Point(usc_ex_P_Calendario_Detalle_FechaHasta.Location.X + 4, usc_ex_P_Calendario_Detalle_FechaHasta.Location.Y - 90);

                        //Titulo de la Pantalla ............................................................................
                        P_Base_TituloPantalla = g_mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento + " - " + Variables_KairosPRO.G_STR_CALENDARIO_DETALLE_TITULO_DIAFESTIVO;
                    }
                    else if (g_int_TipoApertura.Equals(2))//Presencia programada
                    {
                        pnl_P_Calendario_Detalle_Descripcion.Visible = false;
                        pnl_P_Calendario_Detalle_TipoAUPRE_Jornada.Location = new Point(pnl_P_Calendario_Detalle_TipoAUPRE_Jornada.Location.X, (pnl_P_Calendario_Detalle_TipoAUPRE_Jornada.Location.Y - 40));
                        pnl_P_Calendario_Detalle_JornadaCabecera.Location = new Point(pnl_P_Calendario_Detalle_JornadaCabecera.Location.X, pnl_P_Calendario_Detalle_JornadaCabecera.Location.Y - 40);
                        ex_lbl_P_Calendario_Detalle_AUPRE_Programadas.Text = Variables_KairosPRO.G_STR_CALENDARIO_DETALLE_COMBOBOX_PRESENCIAPROGRAMADATIPO;
                        usc_ex_P_Calendario_Detalle_FechaDesde.Location = new Point(usc_ex_P_Calendario_Detalle_FechaDesde.Location.X + 4, usc_ex_P_Calendario_Detalle_FechaDesde.Location.Y - 50);
                        usc_ex_P_Calendario_Detalle_FechaHasta.Location = new Point(usc_ex_P_Calendario_Detalle_FechaHasta.Location.X + 4, usc_ex_P_Calendario_Detalle_FechaHasta.Location.Y - 50);

                        //Titulo de la Pantalla ............................................................................
                        P_Base_TituloPantalla = g_mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento + " - " + Variables_KairosPRO.G_STR_CALENDARIO_DETALLE_TITULO_PRESENCIAPROGRAMADA;
                    }
                    
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Calendario_Detalle) + "/" + nameof(Cargar_Detalle_SegunTipoObjeto));
            }
        }

        private void Generar_FechasDinamicas()
        {
            try
            {
                //hacemos invisible las fechas
                usc_ex_P_Calendario_Detalle_FechaDesde.Visible = false;
                usc_ex_P_Calendario_Detalle_FechaHasta.Visible = false;

                int int_X = 5;
                int int_Y = 10;

                for (int int_Contador = 0; int_Contador < g_lst_Rangos_Fechas.Count; int_Contador++)
                {
                    Exferia_Label ex_lbl_FechaDesdeNombre = new Exferia_Label();
                    ex_lbl_FechaDesdeNombre.Text = "Desde";
                    ex_lbl_FechaDesdeNombre.Location = new Point((int_X), int_Y);
                    ex_lbl_FechaDesdeNombre.AutoSize = true;

                    Exferia_Label ex_lbl_FechaDesde = new Exferia_Label();
                    ex_lbl_FechaDesde.Text = g_lst_Rangos_Fechas[int_Contador][0].ToString("dd/MM/yyyy");
                    ex_lbl_FechaDesde.Location = new Point((int_X + 55), int_Y);


                    Exferia_Label ex_lbl_FechaHastaNombre = new Exferia_Label();
                    ex_lbl_FechaHastaNombre.Text = "Hasta";
                    ex_lbl_FechaHastaNombre.Location = new Point((int_X + 180), int_Y);
                    ex_lbl_FechaHastaNombre.AutoSize = true;

                    Exferia_Label ex_lbl_FechaHasta = new Exferia_Label();
                    ex_lbl_FechaHasta.Text = g_lst_Rangos_Fechas[int_Contador][g_lst_Rangos_Fechas[int_Contador].Count - 1].ToString("dd/MM/yyyy");
                    ex_lbl_FechaHasta.Location = new Point((int_X + 235), int_Y);

                    int_Y += 40;

                    pnl_P_Calendario_Detalle_FechasDinamicas.Controls.Add(ex_lbl_FechaDesdeNombre);
                    pnl_P_Calendario_Detalle_FechasDinamicas.Controls.Add(ex_lbl_FechaDesde);

                    pnl_P_Calendario_Detalle_FechasDinamicas.Controls.Add(ex_lbl_FechaHastaNombre);
                    pnl_P_Calendario_Detalle_FechasDinamicas.Controls.Add(ex_lbl_FechaHasta);

                    pnl_P_Calendario_Detalle_FechasDinamicas.Anchor = AnchorStyles.Bottom | AnchorStyles.Top | AnchorStyles.Left;
                    pnl_P_Calendario_Detalle_FechasDinamicas.Size = new Size(pnl_P_Calendario_Detalle_FechasDinamicas.Size.Width, pnl_P_Calendario_Detalle_FechasDinamicas.Height + 10);
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Calendario_Detalle) + "/" + nameof(Generar_FechasDinamicas));
            }
        }
    }
}
